Whamcloud - gitweb
b=14384
[fs/lustre-release.git] / lustre / tests / sanityN.sh
1 #!/bin/bash
2
3 set -e
4
5 ONLY=${ONLY:-"$*"}
6 # bug number for skipped test:  3192 15528/3811 9977 15528/11549
7 ALWAYS_EXCEPT="                 14b  19         28   29          $SANITYN_EXCEPT"
8 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
9
10 # bug number for skipped test:                                                    12652 12652
11 grep -q 'Enterprise Server 10' /etc/SuSE-release && ALWAYS_EXCEPT="$ALWAYS_EXCEPT 11    14" || true
12
13 # Tests that fail on uml
14 [ "$UML" = "true" ] && EXCEPT="$EXCEPT 7"
15
16 # Join file feature is not supported currently.
17 # It will be ported soon.
18 EXCEPT="$EXCEPT 22"
19
20 SRCDIR=`dirname $0`
21 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
22
23 SIZE=${SIZE:-40960}
24 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
25 CREATETEST=${CREATETEST:-createtest}
26 GETSTRIPE=${GETSTRIPE:-lfs getstripe}
27 SETSTRIPE=${SETSTRIPE:-lstripe}
28 MCREATE=${MCREATE:-mcreate}
29 OPENFILE=${OPENFILE:-openfile}
30 OPENUNLINK=${OPENUNLINK:-openunlink}
31 TOEXCL=${TOEXCL:-toexcl}
32 TRUNCATE=${TRUNCATE:-truncate}
33 export TMP=${TMP:-/tmp}
34 MOUNT_2=${MOUNT_2:-"yes"}
35 CHECK_GRANT=${CHECK_GRANT:-"yes"}
36 GRANT_CHECK_LIST=${GRANT_CHECK_LIST:-""}
37
38 SAVE_PWD=$PWD
39
40 export NAME=${NAME:-local}
41
42 LUSTRE=${LUSTRE:-`dirname $0`/..}
43 . $LUSTRE/tests/test-framework.sh
44 CLEANUP=${CLEANUP:-:}
45 SETUP=${SETUP:-:}
46 init_test_env $@
47 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
48
49 [ "$SLOW" = "no" ] && EXCEPT_SLOW="12 16"
50
51 SANITYLOG=${TESTSUITELOG:-$TMP/$(basename $0 .sh).log}
52 FAIL_ON_ERROR=false
53
54 SETUP=${SETUP:-:}
55 TRACE=${TRACE:-""}
56
57 LPROC=/proc/fs/lustre
58
59 [ "$SANITYLOG" ] && rm -f $SANITYLOG || true
60
61 check_and_setup_lustre
62
63 LPROC=/proc/fs/lustre
64 LOVNAME=`lctl get_param -n llite.*.lov.common_name | tail -n 1`
65 OSTCOUNT=`lctl get_param -n lov.$LOVNAME.numobd`
66
67 rm -rf $DIR1/[df][0-9]* $DIR1/lnk
68
69 # $RUNAS_ID may get set incorrectly somewhere else
70 [ $UID -eq 0 -a $RUNAS_ID -eq 0 ] && error "\$RUNAS_ID set to 0, but \$UID is also 0!"
71
72 check_runas_id $RUNAS_ID $RUNAS
73
74 build_test_filter
75
76 test_1a() {
77         touch $DIR1/f1
78         [ -f $DIR2/f1 ] || error
79 }
80 run_test 1a "check create on 2 mtpt's =========================="
81
82 test_1b() {
83         chmod 777 $DIR2/f1
84         $CHECKSTAT -t file -p 0777 $DIR1/f1 || error
85         chmod a-x $DIR2/f1
86 }
87 run_test 1b "check attribute updates on 2 mtpt's ==============="
88
89 test_1c() {
90         $CHECKSTAT -t file -p 0666 $DIR1/f1 || error
91 }
92 run_test 1c "check after remount attribute updates on 2 mtpt's ="
93
94 test_1d() {
95         rm $DIR2/f1
96         $CHECKSTAT -a $DIR1/f1 || error
97 }
98 run_test 1d "unlink on one mountpoint removes file on other ===="
99
100 test_2a() {
101         touch $DIR1/f2a
102         ls -l $DIR2/f2a
103         chmod 777 $DIR2/f2a
104         $CHECKSTAT -t file -p 0777 $DIR1/f2a || error
105 }
106 run_test 2a "check cached attribute updates on 2 mtpt's ========"
107
108 test_2b() {
109         touch $DIR1/f2b
110         ls -l $DIR2/f2b
111         chmod 777 $DIR1/f2b
112         $CHECKSTAT -t file -p 0777 $DIR2/f2b || error
113 }
114 run_test 2b "check cached attribute updates on 2 mtpt's ========"
115
116 # NEED TO SAVE ROOT DIR MODE
117 test_2c() {
118         chmod 777 $DIR1
119         $CHECKSTAT -t dir -p 0777 $DIR2 || error
120 }
121 run_test 2c "check cached attribute updates on 2 mtpt's root ==="
122
123 test_2d() {
124         chmod 755 $DIR1
125         $CHECKSTAT -t dir -p 0755 $DIR2 || error
126 }
127 run_test 2d "check cached attribute updates on 2 mtpt's root ==="
128
129 test_2e() {
130         chmod 755 $DIR1
131         ls -l $DIR1
132         ls -l $DIR2
133         chmod 777 $DIR1
134         $RUNAS dd if=/dev/zero of=$DIR2/$tfile count=1 || error
135 }
136 run_test 2e "check chmod on root is propagated to others"
137
138 test_3() {
139         ( cd $DIR1 ; ln -s this/is/good lnk )
140         [ "this/is/good" = "`perl -e 'print readlink("'$DIR2/lnk'");'`" ] || \
141                 error
142 }
143 run_test 3 "symlink on one mtpt, readlink on another ==========="
144
145 test_4() {
146         multifstat $DIR1/f4 $DIR2/f4
147 }
148 run_test 4 "fstat validation on multiple mount points =========="
149
150 test_5() {
151         mcreate $DIR1/f5
152         truncate $DIR2/f5 100
153         $CHECKSTAT -t file -s 100 $DIR1/f5 || error
154         rm $DIR1/f5
155 }
156 run_test 5 "create a file on one mount, truncate it on the other"
157
158 test_6() {
159         openunlink $DIR1/$tfile $DIR2/$tfile || \
160                 error "openunlink $DIR1/$tfile $DIR2/$tfile"
161 }
162 run_test 6 "remove of open file on other node =================="
163
164 test_7() {
165         # run_one creates uniq $tdir (bug 13798)
166         # opendirunlink failes if it exists
167         rmdir $DIR1/$tdir || true
168         opendirunlink $DIR1/$tdir $DIR2/$tdir || \
169                 error "opendirunlink $DIR1/$tdir $DIR2/$tdir"
170 }
171 run_test 7 "remove of open directory on other node ============="
172
173 test_8() {
174         opendevunlink $DIR1/$tfile $DIR2/$tfile || \
175                 error "opendevunlink $DIR1/$tfile $DIR2/$tfile"
176 }
177 run_test 8 "remove of open special file on other node =========="
178
179 test_9() {
180         MTPT=1
181         local dir
182         > $DIR2/f9
183         for C in a b c d e f g h i j k l; do
184                 dir=`eval echo \\$DIR$MTPT`
185                 echo -n $C >> $dir/f9
186                 [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
187         done
188         [ "`cat $DIR1/f9`" = "abcdefghijkl" ] || \
189                 error "`od -a $DIR1/f9` != abcdefghijkl"
190 }
191 run_test 9 "append of file with sub-page size on multiple mounts"
192
193 test_10a() {
194         MTPT=1
195         local dir
196         OFFSET=0
197         > $DIR2/f10
198         for C in a b c d e f g h i j k l; do
199                 dir=`eval echo \\$DIR$MTPT`
200                 echo -n $C | dd of=$dir/f10 bs=1 seek=$OFFSET count=1
201                 [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
202                 OFFSET=`expr $OFFSET + 1`
203         done
204         [ "`cat $DIR1/f10`" = "abcdefghijkl" ] || \
205                 error "`od -a $DIR1/f10` != abcdefghijkl"
206 }
207 run_test 10a "write of file with sub-page size on multiple mounts "
208
209 test_10b() {
210         # create a seed file
211         yes "R" | head -c 4000 >$TMP/f10b-seed
212         dd if=$TMP/f10b-seed of=$DIR1/f10b bs=3k count=1 || error "dd $DIR1"
213
214         truncate $DIR1/f10b 4096 || error "truncate 4096"
215
216         dd if=$DIR2/f10b of=$TMP/f10b-lustre bs=4k count=1 || error "dd $DIR2"
217
218         # create a test file locally to compare
219         dd if=$TMP/f10b-seed of=$TMP/f10b bs=3k count=1 || error "dd random"
220         truncate $TMP/f10b 4096 || error "truncate 4096"
221         cmp $TMP/f10b $TMP/f10b-lustre || error "file miscompare"
222         rm $TMP/f10b $TMP/f10b-lustre $TMP/f10b-seed
223 }
224 run_test 10b "write of file with sub-page size on multiple mounts "
225
226 test_11() {
227         mkdir $DIR1/d11
228         multiop_bg_pause $DIR1/d11/f O_c || return 1
229         MULTIPID=$!
230         cp -p /bin/ls $DIR1/d11/f
231         $DIR2/d11/f
232         RC=$?
233         kill -USR1 $MULTIPID
234         wait $MULTIPID || error
235         [ $RC -eq 0 ] && error || true
236 }
237 run_test 11 "execution of file opened for write should return error ===="
238
239 test_12() {
240        DIR=$DIR DIR2=$DIR2 sh lockorder.sh
241 }
242 run_test 12 "test lock ordering (link, stat, unlink) ==========="
243
244 test_13() {     # bug 2451 - directory coherency
245        rm -rf $DIR1/d13
246        mkdir $DIR1/d13 || error
247        cd $DIR1/d13 || error
248        ls
249        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
250        ls
251        rm -f $DIR2/d13/f13 || error
252        ls 2>&1 | grep f13 && error "f13 shouldn't return an error (1)" || true
253        # need to run it twice
254        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
255        ls
256        rm -f $DIR2/d13/f13 || error
257        ls 2>&1 | grep f13 && error "f13 shouldn't return an error (2)" || true
258 }
259 run_test 13 "test directory page revocation ===================="
260
261 test_14() {
262         mkdir $DIR1/d14
263         cp -p /bin/ls $DIR1/d14/ls
264         exec 100>> $DIR1/d14/ls
265         $DIR2/d14/ls && error || true
266         exec 100<&-
267 }
268 run_test 14 "execution of file open for write returns -ETXTBSY ="
269
270 test_14a() {
271         mkdir -p $DIR1/d14
272         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
273         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
274         MULTIOP_PID=$!
275         multiop $DIR2/d14/multiop Oc && error "expected error, got success"
276         kill -USR1 $MULTIOP_PID || return 2
277         wait $MULTIOP_PID || return 3
278         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
279 }
280 run_test 14a "open(RDWR) of executing file returns -ETXTBSY ===="
281
282 test_14b() { # bug 3192, 7040
283         mkdir -p $DIR1/d14
284         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
285         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
286         MULTIOP_PID=$!
287         truncate $DIR2/d14/multiop 0 && kill -9 $MULTIOP_PID && \
288                 error "expected truncate error, got success"
289         kill -USR1 $MULTIOP_PID || return 2
290         wait $MULTIOP_PID || return 3
291         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
292         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
293 }
294 run_test 14b "truncate of executing file returns -ETXTBSY ======"
295
296 test_14c() { # bug 3430, 7040
297         mkdir -p $DIR1/d14
298         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
299         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
300         MULTIOP_PID=$!
301         cp /etc/hosts $DIR2/d14/multiop && error "expected error, got success"
302         kill -USR1 $MULTIOP_PID || return 2
303         wait $MULTIOP_PID || return 3
304         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
305         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
306 }
307 run_test 14c "open(O_TRUNC) of executing file return -ETXTBSY =="
308
309 test_14d() { # bug 10921
310         mkdir -p $DIR1/d14
311         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
312         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
313         MULTIOP_PID=$!
314         log chmod
315         chmod 600 $DIR1/d14/multiop || error "chmod failed"
316         kill -USR1 $MULTIOP_PID || return 2
317         wait $MULTIOP_PID || return 3
318         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
319         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
320 }
321 run_test 14d "chmod of executing file is still possible ========"
322
323 test_15() {     # bug 974 - ENOSPC
324         echo "PATH=$PATH"
325         sh oos2.sh $MOUNT1 $MOUNT2
326         grant_error=`dmesg | grep "> available"`
327         [ -z "$grant_error" ] || error "$grant_error"
328 }
329 run_test 15 "test out-of-space with multiple writers ==========="
330
331 test_16() {
332         rm -f $MOUNT1/fsxfile
333         lfs setstripe $MOUNT1/fsxfile -c -1 # b=10919
334         fsx -c 50 -p 100 -N 2500 -l $((SIZE * 256)) -S 0 $MOUNT1/fsxfile $MOUNT2/fsxfile
335 }
336 run_test 16 "2500 iterations of dual-mount fsx ================="
337
338 test_17() { # bug 3513, 3667
339         [ ! -d /proc/fs/lustre/ost ] && skip "remote OST, skipping OST-only test" && return
340
341         cp /etc/termcap $DIR1/f17
342         cancel_lru_locks osc > /dev/null
343         #define OBD_FAIL_ONCE|OBD_FAIL_LDLM_CREATE_RESOURCE    0x30a
344         lctl set_param fail_loc=0x8000030a
345         ls -ls $DIR1/f17 | awk '{ print $1,$6 }' > $DIR1/f17-1 & \
346         ls -ls $DIR2/f17 | awk '{ print $1,$6 }' > $DIR2/f17-2
347         wait
348         diff -u $DIR1/f17-1 $DIR2/f17-2 || error "files are different"
349 }
350 run_test 17 "resource creation/LVB creation race ==============="
351
352 test_18() {
353         ./mmap_sanity -d $MOUNT1 -m $MOUNT2
354         sync; sleep 1; sync
355 }
356 run_test 18 "mmap sanity check ================================="
357
358 test_19() { # bug3811
359         [ -d /proc/fs/lustre/obdfilter ] || return 0
360
361         MAX=`cat /proc/fs/lustre/obdfilter/*/readcache_max_filesize | head -n 1`
362         for O in /proc/fs/lustre/obdfilter/*OST*; do
363                 echo 4096 > $O/readcache_max_filesize
364         done
365         dd if=/dev/urandom of=$TMP/f19b bs=512k count=32
366         SUM=`cksum $TMP/f19b | cut -d" " -f 1,2`
367         cp $TMP/f19b $DIR1/f19b
368         for i in `seq 1 20`; do
369                 [ $((i % 5)) -eq 0 ] && log "test_18 loop $i"
370                 cancel_lru_locks osc > /dev/null
371                 cksum $DIR1/f19b | cut -d" " -f 1,2 > $TMP/sum1 & \
372                 cksum $DIR2/f19b | cut -d" " -f 1,2 > $TMP/sum2
373                 wait
374                 [ "`cat $TMP/sum1`" = "$SUM" ] || \
375                         error "$DIR1/f19b `cat $TMP/sum1` != $SUM"
376                 [ "`cat $TMP/sum2`" = "$SUM" ] || \
377                         error "$DIR2/f19b `cat $TMP/sum2` != $SUM"
378         done
379         for O in /proc/fs/lustre/obdfilter/*OST*; do
380                 echo $MAX > $O/readcache_max_filesize
381         done
382         rm $DIR1/f19b
383 }
384 run_test 19 "test concurrent uncached read races ==============="
385
386 test_20() {
387         mkdir $DIR1/d20
388         cancel_lru_locks osc
389         CNT=$((`cat /proc/fs/lustre/llite/*/dump_page_cache | wc -l`))
390         multiop $DIR1/f20 Ow8190c
391         multiop $DIR2/f20 Oz8194w8190c
392         multiop $DIR1/f20 Oz0r8190c
393         cancel_lru_locks osc
394         CNTD=$((`cat /proc/fs/lustre/llite/*/dump_page_cache | wc -l` - $CNT))
395         [ $CNTD -gt 0 ] && \
396             error $CNTD" page left in cache after lock cancel" || true
397 }
398 run_test 20 "test extra readahead page left in cache ===="
399
400 cleanup_21() {
401         trap 0
402         umount $DIR1/d21
403 }
404
405 test_21() { # Bug 5907
406         mkdir $DIR1/d21
407         mount /etc $DIR1/d21 --bind || error "mount failed" # Poor man's mount.
408         trap cleanup_21 EXIT
409         rmdir -v $DIR1/d21 && error "Removed mounted directory"
410         rmdir -v $DIR2/d21 && echo "Removed mounted directory from another mountpoint, needs to be fixed"
411         test -d $DIR1/d21 || error "Mounted directory disappeared"
412         cleanup_21
413         test -d $DIR2/d21 || test -d $DIR1/d21 && error "Removed dir still visible after umount"
414         true
415 }
416 run_test 21 " Try to remove mountpoint on another dir ===="
417
418 JOIN=${JOIN:-"lfs join"}
419
420 test_22() { # Bug 9926
421         mkdir $DIR1/d21
422         dd if=/dev/urandom of=$DIR1/d21/128k bs=1024 count=128
423         cp -p $DIR1/d21/128k $DIR1/d21/f_head
424         for ((i=0;i<10;i++)); do
425                 cp -p $DIR1/d21/128k $DIR1/d21/f_tail
426                 $JOIN $DIR1/d21/f_head $DIR1/d21/f_tail || error "join error"
427                 $CHECKSTAT -a $DIR1/d21/f_tail || error "tail file exist after join"
428         done
429         echo aaaaaaaaaaa >> $DIR1/d21/no_joined
430
431         mv $DIR2/d21/f_head $DIR2/
432         munlink $DIR2/f_head || error "unlink joined file error"
433         cat $DIR2/d21/no_joined || error "cat error"
434         rm -rf $DIR2/d21/no_joined || error "unlink normal file error"
435 }
436 run_test 22 " After joining in one dir,  open/close unlink file in anther dir" 
437
438 test_23() { # Bug 5972
439         echo "others should see updated atime while another read" > $DIR1/f23
440         
441         # clear the lock(mode: LCK_PW) gotten from creating operation
442         cancel_lru_locks osc
443         
444         time1=`date +%s`        
445         sleep 2
446         
447         multiop_bg_pause $DIR1/f23 or20_c || return 1
448         MULTIPID=$!
449
450         time2=`stat -c "%X" $DIR2/f23`
451
452         if (( $time2 <= $time1 )); then
453                 kill -USR1 $MULTIPID
454                 error "atime doesn't update among nodes"
455         fi
456
457         kill -USR1 $MULTIPID || return 1
458         rm -f $DIR1/f23 || error "rm -f $DIR1/f23 failed"
459         true
460 }
461 run_test 23 " others should see updated atime while another read===="
462
463 test_24() {
464         touch $DIR1/$tfile
465         lfs df || error "lfs df failed"
466         lfs df -ih || error "lfs df -ih failed"
467         lfs df -h $DIR1 || error "lfs df -h $DIR1 failed"
468         lfs df -i $DIR2 || error "lfs df -i $DIR2 failed"
469         lfs df $DIR1/$tfile || error "lfs df $DIR1/$tfile failed"
470         lfs df -ih $DIR2/$tfile || error "lfs df -ih $DIR2/$tfile failed"
471         
472         OSC=`lctl dl | awk '/-osc-|OSC.*MNT/ {print $4}' | head -n 1`
473 #       OSC=`lctl dl | awk '/-osc-/ {print $4}' | head -n 1`
474         lctl --device %$OSC deactivate
475         lfs df -i || error "lfs df -i with deactivated OSC failed"
476         lctl --device %$OSC recover
477         lfs df || error "lfs df with reactivated OSC failed"
478 }
479 run_test 24 "lfs df [-ih] [path] test ========================="
480
481 test_25() {
482         [ `lctl get_param -n mdc.*-mdc-*.connect_flags | grep -c acl` -lt 2 ] && \
483             skip "must have acl, skipping" && return
484
485         touch $DIR1/$tdir/f1 || error "touch $DIR1/$tdir/f1"
486         chmod 0755 $DIR1/$tdir/f1 || error "chmod 0755 $DIR1/$tdir/f1"
487
488         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #1"
489         setfacl -m u:$RUNAS_ID:--- $DIR1/$tdir || error "setfacl $DIR2/$tdir #1"
490         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #2"
491         setfacl -m u:$RUNAS_ID:r-x $DIR1/$tdir || error "setfacl $DIR2/$tdir #2"
492         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #3"
493         setfacl -m u:$RUNAS_ID:--- $DIR1/$tdir || error "setfacl $DIR2/$tdir #3"
494         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #4"
495         setfacl -x u:$RUNAS_ID: $DIR1/$tdir || error "setfacl $DIR2/$tdir #4"
496         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #5"
497
498         rm -rf $DIR1/$tdir
499 }
500 run_test 25 "change ACL on one mountpoint be seen on another ==="
501
502 test_26a() {
503         utime $DIR1/f26a -s $DIR2/f26a || error
504 }
505 run_test 26a "allow mtime to get older"
506
507 test_26b() {
508         touch $DIR1/$tfile
509         sleep 1
510         echo "aaa" >> $DIR1/$tfile
511         sleep 1
512         chmod a+x $DIR2/$tfile
513         mt1=`stat -c %Y $DIR1/$tfile`
514         mt2=`stat -c %Y $DIR2/$tfile`
515         
516         if [ x"$mt1" != x"$mt2" ]; then 
517                 error "not equal mtime, client1: "$mt1", client2: "$mt2"."
518         fi
519 }
520 run_test 26b "sync mtime between ost and mds"
521
522 test_27() {
523         cancel_lru_locks osc
524         lctl clear
525         dd if=/dev/zero of=$DIR2/$tfile bs=$((4096+4))k conv=notrunc count=4 seek=3 &
526         DD2_PID=$!
527         usleep 50
528         log "dd 1 started"
529         
530         dd if=/dev/zero of=$DIR1/$tfile bs=$((16384-1024))k conv=notrunc count=1 seek=4 &
531         DD1_PID=$!
532         log "dd 2 started"
533         
534         sleep 1
535         dd if=/dev/zero of=$DIR1/$tfile bs=8k conv=notrunc count=1 seek=0
536         log "dd 3 finished"
537         lctl set_param -n ldlm.dump_namespaces ""
538         wait $DD1_PID $DD2_PID
539         [ $? -ne 0 ] && lctl dk $TMP/debug || true
540 }
541 run_test 27 "align non-overlapping extent locks from request ==="
542
543 test_28() { # bug 9977
544         ECHO_UUID="ECHO_osc1_UUID"
545         tOST=`$LCTL dl | | awk '/-osc-|OSC.*MNT/ { print $4 }' | head -1`
546
547         lfs setstripe $DIR1/$tfile -s 1048576 -i 0 -c 2
548         tOBJID=`lfs getstripe $DIR1/$tfile |grep "^[[:space:]]\+1" |awk '{print $2}'`
549         dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2
550
551         $LCTL <<-EOF
552                 newdev
553                 attach echo_client ECHO_osc1 $ECHO_UUID
554                 setup $tOST
555         EOF
556
557         tECHOID=`$LCTL dl | grep $ECHO_UUID | awk '{print $1}'`
558         $LCTL --device $tECHOID destroy "${tOBJID}:0"
559     
560         $LCTL <<-EOF
561                 cfg_device ECHO_osc1
562                 cleanup
563                 detach
564         EOF
565
566         # reading of 1st stripe should pass
567         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
568         # reading of 2nd stripe should fail (this stripe was destroyed)
569         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 && error
570
571         # now, recreating test file
572         dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2 || error
573         # reading of 1st stripe should pass
574         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
575         # reading of 2nd stripe should pass
576         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 || error
577 }
578 run_test 28 "read/write/truncate file with lost stripes"
579
580 test_29() { # bug 10999
581         touch $DIR1/$tfile
582         #define OBD_FAIL_LDLM_GLIMPSE  0x30f
583         lctl set_param fail_loc=0x8000030f
584         ls -l $DIR2/$tfile &
585         usleep 500
586         dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1
587         wait
588 }
589 #bug 11549 - permanently turn test off in b1_5
590 run_test 29 "lock put race between glimpse and enqueue ========="
591
592 test_30() { #bug #11110
593     cp -f /bin/bash $DIR1/$tdir/bash
594     /bin/sh -c 'sleep 1; rm -f $DIR2/$tdir/bash; cp /bin/bash $DIR2/$tdir' &
595     err=$($DIR1/$tdir/bash -c 'sleep 2; openfile -f O_RDONLY /proc/$$/exe >& /dev/null; echo $?')
596     wait
597     [ $err -ne 116 ] && error_ignore 12900 "return code ($err) != -ESTALE" && return
598     true
599 }
600
601 run_test 30 "recreate file race ========="
602
603 test_31() {
604         mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
605         writes=`LANG=C dd if=/dev/zero of=$DIR/$tdir/$tfile count=1 2>&1 |
606                 awk 'BEGIN { FS="+" } /out/ {print $1}'`
607         #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
608         lctl set_param fail_loc=0x314
609         reads=`LANG=C dd if=$DIR2/$tdir/$tfile of=/dev/null 2>&1 |
610                awk 'BEGIN { FS="+" } /in/ {print $1}'`
611         [ $reads -eq $writes ] || error "read" $reads "blocks, must be" $writes
612 }
613 run_test 31 "voluntary cancel / blocking ast race=============="
614
615 # enable/disable lockless truncate feature, depending on the arg 0/1
616 enable_lockless_truncate() {
617         lctl set_param -n llite.*.lockless_truncate $1
618 }
619
620 test_32a() { # bug 11270
621         local p="$TMP/sanityN-$TESTNAME.parameters"
622         save_lustre_params $HOSTNAME llite.*.lockless_truncate > $p
623         cancel_lru_locks osc
624         clear_llite_stats
625         enable_lockless_truncate 1
626         dd if=/dev/zero of=$DIR1/$tfile count=10 bs=1M > /dev/null 2>&1
627
628         log "checking cached lockless truncate"
629         $TRUNCATE $DIR1/$tfile 8000000
630         $CHECKSTAT -s 8000000 $DIR2/$tfile || error "wrong file size"
631         [ $(calc_llite_stats lockless_truncate) -eq 0 ] ||
632                 error "lockless truncate doesn't use cached locks"
633
634         log "checking not cached lockless truncate"
635         $TRUNCATE $DIR2/$tfile 5000000
636         $CHECKSTAT -s 5000000 $DIR1/$tfile || error "wrong file size"
637         [ $(calc_llite_stats lockless_truncate) -ne 0 ] ||
638                 error "not cached trancate isn't lockless"
639
640         log "disabled lockless truncate"
641         enable_lockless_truncate 0
642         clear_llite_stats
643         $TRUNCATE $DIR2/$tfile 3000000
644         $CHECKSTAT -s 3000000 $DIR1/$tfile || error "wrong file size"
645         [ $(calc_llite_stats lockless_truncate) -eq 0 ] ||
646                 error "lockless truncate disabling failed"
647         rm $DIR1/$tfile
648         # restore lockless_truncate default values
649         restore_lustre_params < $p
650         rm -f $p
651 }
652 run_test 32a "lockless truncate"
653
654 test_32b() { # bug 11270
655         local node
656         local p="$TMP/sanityN-$TESTNAME.parameters"
657         save_lustre_params $HOSTNAME "llite.*.contention_seconds" > $p
658         for node in $(osts_nodes); do
659                 save_lustre_params $node "ldlm.namespaces.filter-*.max_nolock_bytes" >> $p
660                 save_lustre_params $node "ldlm.namespaces.filter-*.contended_locks" >> $p
661                 save_lustre_params $node "ldlm.namespaces.filter-*.contention_seconds" >> $p
662         done
663         clear_llite_stats
664         # agressive lockless i/o settings 
665         for node in $(osts_nodes); do
666                 do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 2000000; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 0; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 60'
667         done
668         lctl set_param -n llite.*.contention_seconds 60
669         for i in $(seq 5); do
670                 dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
671                 dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
672         done
673         [ $(calc_llite_stats lockless_write_bytes) -ne 0 ] || error "lockless i/o was not triggered" 
674         # disable lockless i/o (it is disabled by default)
675         for node in $(osts_nodes); do
676                 do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 0; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 32; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 0'
677         done
678         # set contention_seconds to 0 at client too, otherwise Lustre still
679         # remembers lock contention
680         lctl set_param -n llite.*.contention_seconds 0
681         clear_llite_stats
682         for i in $(seq 5); do
683                 dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
684                 dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
685         done
686         [ $(calc_llite_stats lockless_write_bytes) -eq 0 ] ||
687                 error "lockless i/o works when disabled" 
688         rm -f $DIR1/$tfile
689         restore_lustre_params <$p
690         rm -f $p
691 }
692 run_test 32b "lockless i/o"
693
694 log "cleanup: ======================================================"
695
696 check_and_cleanup_lustre
697
698 echo '=========================== finished ==============================='
699 [ -f "$SANITYLOG" ] && cat $SANITYLOG && grep -q FAIL $SANITYLOG && exit 1 || true
700 echo "$0: completed"